/*  This file contains the definition of a robot that can add beepers to piles,
in addition to the capabilities of a TurningRobot.

written by Scott McElfresh
*/

package kareltherobot;


public class PileAdderRobot extends TurningRobot 
{
        public PileAdderRobot(int street, int avenue,Direction dir, int num)
        {       
           super(street, avenue, dir, num);
        }
		

		/**
		  Find a pile that is directly in front of the robot.  If there is no pile, it has an infinite loop.  
		  ASSUMES: no wall between it and pile
		*/
		private void goToPile()
		{
		   while (! nextToABeeper())
		   {
		      move();
		   }
		}
		
		/**
	        Returns robot to the left side of the world.  
			ASSUMES:  robot is facing east, and no extraneous walls block its path the the left side of 
			the world (the west wall)
		*/
		private void returnToLeft()
		{
		  turnAround();
		  while (frontIsClear())
		     move();
		}
		
		/**
		   Have robot add one beeper to a pile that is to its East and return to the west wall.
		   ASSUMES: robot is facing East and has a beeper to put
		*/
		public void addToPile()
		{
		   goToPile();
		   putBeeper();
		   returnToLeft();
		}
		
		/**
		   Have robot add all of its beepers to a pile that is to its East and return to the west wall.
		   ASSUMES: robot is facing East
		*/
		public void addAllToPile()
		{
		  goToPile();
		  while (anyBeepersInBeeperBag())
		      putBeeper();
		  returnToLeft();
		}
		
		
}